grails-app/controllers/transmartapp/ExperimentController.groovy
package transmartapp

import grails.converters.JSON
import org.transmart.biomart.Experiment
import org.transmart.searchapp.*

class ExperimentController {

    def SpringSecurityService;
    def gwasWebService;

    /**
     * Find the top 20 experiments with a case-insensitive LIKE
     */
    def extSearch = {
        def paramMap = params
        def value = params.term.toUpperCase();
        def studyType = params.studyType?.toUpperCase();

        def experiments = Experiment.executeQuery("SELECT accession, title FROM Experiment e WHERE upper(e.title) LIKE '%' || :term || '%' AND upper(e.type) = :studyType", [term: value, studyType: studyType], [max: 20]);

        def category = "STUDY"
        def categoryDisplay = "Study"
        if (studyType.equals('I2B2')) {
            category = "i2b2"
            categoryDisplay = "i2b2"
        }
        def itemlist = [];
        for (exp in experiments) {
            itemlist.add([id: exp[0], keyword: exp[1], category: category, display: categoryDisplay]);
        }

        render itemlist as JSON;
    }

    /**
     * This will display a list of the available studies in the system to the user. The user will only be able to select one item from the dropdown.
     */
    def browseExperimentsSingleSelect = {

        def experiments
        def user=AuthUser.findByUsername(springSecurityService.getPrincipal().username)
        def secObjs= getExperimentSecureStudyList()

        if (params.type) {
            experiments = Experiment.findAllByType(params.type)
            experiments = getSortedList(experiments)
        } else {
            experiments = Experiment.list()
            experiments = getSortedList(experiments)
        }

        experiments=experiments.findAll{!secObjs.containsKey(it.accession) || !gwasWebService.getGWASAccess(it.accession, user).equals("Locked") }
        render(template: 'browseSingle', model: [experiments: experiments])
    }

    /**
     *
     * Get list of secured (i.e. private) experiment.
     *
     */

    def getExperimentSecureStudyList(){  
		
        StringBuilder s = new StringBuilder();
        s.append("SELECT so.bioDataUniqueId, so.bioDataId FROM SecureObject so Where so.dataType='Experiment'")
        def t=[:];
        //return access levels for the children of this path that have them
        def results = SecureObject.executeQuery(s.toString());
        for (row in results){
            def token = row[0];
            def dataid = row[1];
            token=token.replaceFirst("EXP:","")
            log.info(token+":"+dataid);
            t.put(token,dataid);
        }
        return t;
    }
	
    /**
     * This will render a UI where the user can pick an experiment from a list of all the experiments in the system. Selection of multiple studies is allowed.
     */
    def browseExperimentsMultiSelect = {

        def experiments

        if (params.type) {
            experiments = Experiment.findAllByType(params.type)
            experiments = getSortedList(experiments)
        } else {
            experiments = Experiment.list()
            experiments = getSortedList(experiments)
        }

        render(template: 'browseMulti', model: [experiments: experiments])
    }

    def getSortedList(experiments) {

        experiments.sort({ a, b ->
            return a.title.trim().compareToIgnoreCase(b.title.trim());
        })

        return experiments
    }

}

grails-app/views/experiment/_browseMulti.gsp
<%--<script type="text/javascript" src="${resource(dir:'js', file:'jquery/ui.multiselect.js')}"></script>--%>

<script type="text/javascript">
    jQuery(function () {
        // choose either the full version
        jQuery(".multiselect").multiselect();
        // or disable some features
        //jQuery(".multiselect").multiselect({sortable: false, searchable: false});
    });
</script>

<select id="multiselectbox" class="multiselect" multiple="multiple" name="experiments[]">
    <g:each in="${experiments}" var="experiment">
        <option value="${experiment.id}">${experiment.title}</option>
    </g:each>
</select>

grails-app/views/experiment/_browseSingle.gsp
<style type="text/css">
.studyBrowseRow.selected {
    border: 1px solid #AED0EA;
    background-color: #D7EBF9;
}

table.studyBrowseTable {
    border-collapse: collapse;
}

table.studyBrowseTable > tbody > tr {
    cursor: pointer;
    padding: 4px;
}

table.studyBrowseTable > tbody > tr > td {
    padding: 4px 0px;
    font-size: 10px;
}
</style>
<script type="text/javascript" src="${resource(dir: 'js', file: 'jquery/ui.multiselect.js')}"></script>
<script type="text/javascript">
    $j(document).ready(function () {
        $j(".studyBrowseRow").click(function () {
            $j('.studyBrowseRow').removeClass('selected');
            $j(this).addClass('selected');
        });
    });

</script>
<table class="studyBrowseTable"><thead><tr><th>Accession</th><th>Name</th></tr></thead>
    <tbody>
    <g:each in="${experiments}" var="experiment">
        <tr class="studyBrowseRow" id="${experiment.accession}"><td>${experiment.accession}</td><td
                id="studyBrowseName${experiment.accession}">${experiment.title}</td></tr>
    </g:each>
    </tbody>
</table>

grails-app/views/experiment/_expDetail.gsp
<g:set var="overlayDiv" value="metaData_div" />
<script type="text/javascript">
var analysisCount = 1
var assayCount = 3

    $j(document).ready(function() 
    {     
        var dt1 = new dataTableWrapper('gridViewWrapper1', 'gridViewTable1', 'Analysis (' + analysisCount + ")");
        dt1.loadData(${jSONForGrid});

        var dt2 = new dataTableWrapper('gridViewWrapper2', 'gridViewTable2', 'Assays (' + assayCount + ')');
        dt2.loadData(${jSONForGrid1});
        
     });
</script>

<g:if test="${!layout}">
    <i>No columns have been set up for the study view</i>
</g:if>

<div style="margin:10px;padding:10px;">
    <h3 class="rdc-h3">${experimentInstance?.title}</h3>
    <div style="line-height:14px;font-family:arial,​tahoma,​helvetica,​sans-serif; font-size: 12px;">
    <g:if test="${experimentInstance?.description != null && experimentInstance?.description.length() > 325000}">
        ${(experimentInstance?.description).substring(0,324000)}&nbsp;&nbsp;
        <a href=# >...See more</a>
    </g:if>
    <g:elseif test="${experimentInstance?.description != null}">
        ${experimentInstance?.description}
    </g:elseif>
</div>
<div style="height:20px;"></div>

<div style="width:800px; border:2px solid #DDD; border-radius:8px;-moz-border-radius: 8px;">
    <table class="details-table">
        <thead style="border-radius:8px;-moz-border-radius: 8px;">
            <tr style="border-radius:8px;-moz-border-radius: 8px;">   
                <th style="border-radius:8px;-moz-border-radius: 8px;">&nbsp;</th>
                <th align="right"><g:remoteLink controller="fmFolder" action="editMetaData" update="${overlayDiv}" 
                    params="[eleId:overlayDiv, experimentId:experimentInstance.id]" 
                    before="initLoadingDialog('${overlayDiv}')" onComplete="centerDialog('${overlayDiv}')">
                    <img align="right" src="${resource(dir:'images', file:'pencil.png')}"/></g:remoteLink>
                </th>
            </tr>
        </thead>
            
        <tbody>
            <g:each in="${layout}" status="i" var="layoutRow">
                <g:if test="${layoutRow.display}">
                    <tr class='details-row'> <!-- class="${(i % 2) == 0 ? 'odd' : 'even'}"> -->
                        <td valign="top" align="right" class="columnname" width="20%">${layoutRow.displayName}</td>

                        <td valign="top" align="left" class="columnvalue" width="80%">
                            <g:if test="${layoutRow.dataType == 'date'}">
                                <g:fieldDate bean="${experimentInstance}" field="${layoutRow.column}" format="yyyy-MM-dd"/>
                            </g:if>

                            <%-- Special cases --%>
                            <g:elseif test="${layoutRow.dataType == 'special'}">
                                <g:if test="${layoutRow.column == 'accession'}">
                                    ${fieldValue(bean:experimentInstance,field:'accession')}
                                    <g:if test="${experimentInstance?.files.size() > 0}">
                                        <g:set var="fcount" value="${0}" />
                                        <g:each in="${experimentInstance.files}" var="file">
                                            <g:if test="${file.content.type=='Experiment Web Link'}">
                                                <g:set var="fcount" value="${fcount++}" />
                                                <g:if test="${fcount > 1}">, </g:if>
                                                <g:createFileLink content="${file.content}"
                                                                  displayLabel="${file.content.repository.repositoryType}"/>
                                            </g:if>
                                            <g:elseif test="${file.content.type=='Dataset Explorer Node Link'&&search==1}">
                                                <g:link controller="datasetExplorer" action="index" params="[path:file.content.location]">Dataset Explorer<img src="${resource(dir:'images', file:'internal-link.gif')}"/></g:link>
                                            </g:elseif>
                                        </g:each>
                                    </g:if>
                                    <g:if test="${searchId!=null}">
                                        | <g:link controller="search" action="newSearch" id="${searchId}">Search analyzed Data <img src="${resource(dir:'images', file:'internal-link.gif')}"/></g:link>
                                    </g:if>
                                </g:if>
                                <g:elseif test="${layoutRow.column == 'platforms'}">
                                    <g:each var="pf" in="${expPlatforms}">
                                        ${pf?.name.encodeAsHTML()}<br>
                                    </g:each>
                                </g:elseif>
                                <g:elseif test="${layoutRow.column == 'organism'}">
                                    <g:each var="og" in="${expOrganisms}">
                                        ${og?.encodeAsHTML()}<br>
                                    </g:each>
                                </g:elseif>
                            </g:elseif>

                            <g:else> <%-- In all other cases, display as string --%>
                                <g:if test="${fieldValue(bean:experimentInstance,field:layoutRow.column).length() > 325}">
                                    ${(fieldValue(bean:experimentInstance,field:layoutRow.column)).substring(0,324)}&nbsp;&nbsp;
                                    <a href=# >...See more</a>
                                </g:if>
                                <g:else>
                                    ${fieldValue(bean:experimentInstance,field:layoutRow.column)}
                                </g:else>
                            </g:else>
                        </td>
                    </tr>
                </g:if>
            </g:each>
        </tbody>
        <thead>
            <tr>                
                <th>&nbsp;</th>
                <th align="right">
                    <div align="right">Subject1&nbsp;Level&nbsp;Data&nbsp;is&nbsp;available&nbsp;
                        <a href="#subjectFake" onclick="showTab('analyze')"><img src="${resource(dir:'images', file:'application_go.png')}"/></a>
                    </div>
                </th>
            </tr>
        </thead>

    </table>
</div>
<span></span>
                    
       <div style="height:20px;"></div>
       <div style="width:1100px">
            <div id='gridViewWrapper1'>
            </div>        
        </div>

       <div style="height:30px;"></div>
       <div style="width:1100px">
            <div id='gridViewWrapper2'>
            </div>        
        </div>

<!--  overlay div  -->

<g:overlayDiv divId="${overlayDiv}" />
</div>
 
 <!-- background-color:#9CA4E4;  -->

grails-app/views/experiment/noresults.gsp
<html>
<body>
<br><br><br>

<p style="text-align: center;">Unfortunately, there is no metadata for this experiment</p>
</body>
</html>

grails-app/views/experiment/show.gsp
<%@ page import="org.transmart.biomart.Experiment" %>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta name="layout" content="main"/>
    <title>Show Experiment</title>
</head>

<body>
<div class="nav">
    <span class="menuButton"><a class="home" href="${resource(dir: '')}">Home</a></span>
    <span class="menuButton"><g:link class="list" action="list">Experiment List</g:link></span>
    <span class="menuButton"><g:link class="create" action="create">New Experiment</g:link></span>
</div>

<div class="body">
    <h1>Show Experiment</h1>
    <g:if test="${flash.message}">
        <div class="message">${flash.message}</div>
    </g:if>
    <div class="dialog">
        <table>
            <tbody>

            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.id" default="Id"/>:</td>

                <td valign="top" class="value">${fieldValue(bean: experimentInstance, field: 'id')}</td>

            </tr>


            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.type" default="Type"/>:</td>

                <td valign="top" class="value">${fieldValue(bean: experimentInstance, field: 'type')}</td>

            </tr>


            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.title" default="Title"/>:</td>

                <td valign="top" class="value">${fieldValue(bean: experimentInstance, field: 'title')}</td>

            </tr>


            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.description"
                                                         default="Description"/>:</td>

                <td valign="top" class="value">${fieldValue(bean: experimentInstance, field: 'description')}</td>

            </tr>


            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.design" default="Design"/>:</td>

                <td valign="top" class="value">${fieldValue(bean: experimentInstance, field: 'design')}</td>

            </tr>


            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.startDate"
                                                         default="Start Date"/>:</td>

                <td valign="top" class="value">${fieldValue(bean: experimentInstance, field: 'startDate')}</td>

            </tr>


            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.completionDate"
                                                         default="Completion Date"/>:</td>

                <td valign="top" class="value">${fieldValue(bean: experimentInstance, field: 'completionDate')}</td>

            </tr>


            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.primaryInvestigator"
                                                         default="Primary Investigator"/>:</td>

                <td valign="top"
                    class="value">${fieldValue(bean: experimentInstance, field: 'primaryInvestigator')}</td>

            </tr>


            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.compounds" default="Compounds"/>:</td>

                <td valign="top" style="text-align:left;" class="value">
                    <ul>
                        <g:each var="c" in="${experimentInstance.compounds}">
                            <li><g:link controller="compound" action="show"
                                        id="${c.id}">${c?.encodeAsHTML()}</g:link></li>
                        </g:each>
                    </ul>
                </td>

            </tr>


            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.diseases" default="Diseases"/>:</td>

                <td valign="top" style="text-align:left;" class="value">
                    <ul>
                        <g:each var="d" in="${experimentInstance.diseases}">
                            <li><g:link controller="disease" action="show"
                                        id="${d.id}">${d?.encodeAsHTML()}</g:link></li>
                        </g:each>
                    </ul>
                </td>

            </tr>


            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.files" default="Docs"/>:</td>

                <td valign="top" style="text-align:left;" class="value">
                    <ul>
                        <g:each var="d" in="${experimentInstance.files}">
                            <li><g:link controller="contentReference" action="show"
                                        id="${d.id}">${d?.encodeAsHTML()}</g:link></li>
                        </g:each>
                    </ul>
                </td>

            </tr>


            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.uniqueIds"
                                                         default="Unique Ids"/>:</td>

                <td valign="top" style="text-align:left;" class="value">
                    <ul>
                        <g:each var="u" in="${experimentInstance.uniqueIds}">
                            <li><g:link controller="bioData" action="show"
                                        id="${u.id}">${u?.encodeAsHTML()}</g:link></li>
                        </g:each>
                    </ul>
                </td>

            </tr>


            <tr class="prop">
                <td valign="top" class="name"><g:message code="experimentInstance.uniqueId" default="Unique Id"/>:</td>

                <td valign="top" class="value">${fieldValue(bean: experimentInstance, field: 'uniqueId')}</td>

            </tr>

            </tbody>
        </table>
    </div>

    <div class="buttons">
        <g:form>
            <input type="hidden" name="id" value="${experimentInstance?.id}"/>
            <span class="button"><g:actionSubmit class="edit" value="Edit"/></span>
            <span class="button"><g:actionSubmit class="delete" onclick="return confirm('Are you sure?');"
                                                 value="Delete"/></span>
        </g:form>
    </div>
</div>
</body>
</html>